import sys
import os

import re
import urllib
import time
import os.path
import pprint
import shutil
import psycopg2
from sshtunnel import SSHTunnelForwarder
import json
import datetime
from inspect import getsourcefile
from os.path import abspath

from ..util.data import Auth
from ..util.data import BRSValues

def post_query(query_string=None,
               query_file=None,
               query_gen=None,
               query_type='string'):
    """
    Opens an SSH Tunnel to the Albatross database, and returns response based on database response to passed query

    :param query_gen:
    :param query_type:
    :param query_string: - This will be the full string (in triple quotes to be safe) of the query to execute
    :param query_file: - This is for if you have
    :return:
        -1 for no parameters,
        -2 for wrong file type,
        None if no results
        List of lists responses if they exist
    """

    if query_string is None and query_file is None and query_gen is None:
        return -1

    if isinstance(query_string, str) is True:
        query_to_pass = query_string

    elif isinstance(query_file, str) is True:
        with open(query_file, "r") as query_file_inst:
            query_file_text = query_file_inst.read()
            #print(query_file_text)
            query_to_pass = query_file_text

    elif isinstance(query_gen, str) is True:
        if query_type == 'string':
            query_to_pass = query_gen

    else:
        return -2

    with SSHTunnelForwarder(
            (BRSValues.DBConnection.ssh_tunnel_address, BRSValues.DBConnection.ssh_tunnel_port),
            ssh_username=BRSValues.DBConnection.ssh_username,
            ssh_private_key=BRSValues.DBConnection.ssh_private_rsa_key_path,
            remote_bind_address=(BRSValues.DBConnection.database_remote_bind_address,
                                 BRSValues.DBConnection.database_port)) as tunnel:
        conn = None
        tunnel.start()
        with psycopg2.connect(
                database=BRSValues.DBConnection.database_name,
                user=BRSValues.DBConnection.database_username,
                password=BRSValues.DBConnection.database_password,
                host=BRSValues.DBConnection.database_host,
                port=tunnel.local_bind_port
        ) as connection:

            if True:
                cur = connection.cursor()
                print('Connected to Albatross database')
                print('Making query request')

                # Execute the query
                cur.execute(f'{query_to_pass}')
                query_response = cur.fetchall()

                if not query_response:
                    return None

                else:
                    return query_response

