current_finch_last_updated = r"10/21/2021 6:08 AM"
current_finch_version = r"2.0 alpha"
finch_query_string = """
                    with 
                    primary_financier as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.int_value "int_value",
                            lov.name "text_value",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga on 
                            cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 586
                            
                    )
                    ,
                    loan_term as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.int_value "int_value",
                            lov.name "text_value",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga on 
                            cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 378
                    )
                    ,
                    interest_rate as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.numeric_value "numeric_value",		
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 160
                    )
                    ,
                    loan_amount as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.numeric_value "numeric_value",		
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 173
                    )
                    ,
                    d_and_f_proposal_number as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",		
                            plh.proposal_nbr as "proposal_number",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join brs.proposal_log_history plh 
                            on plh.project_id = pps.project_id 
                            and 
                            plh.id = ppscfv.int_value
                        
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 622
                    )
                    ,
                    d_and_f_design_number as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",		
                            dlh.reference_nbr as "design_number",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join brs.design_log_history dlh 
                            on dlh.project_id = pps.project_id and dlh.id = ppscfv.int_value
                        
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 9109
                    )
                    ,
                    loan_product as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.int_value "int_value",
                            lov.name "text_value",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 261
                    )
                    ,
                    design_type as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.int_value "int_value",
                            lov.name "text_value",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 10626
                    )
                    ,
                    kwh_change as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.int_value "int_value",
                            lov.name "text_value",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 166
                    )
                    ,
                    price_change as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.int_value "int_value",
                            lov.name "text_value",
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 260
                    )
                    ,
                    fd_sent_timestamp as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            ppscfv.timestamp_value "timestamp_value",
                            
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 103
                    )
					,
					ee_review_needed as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            lov.name "text_value",
                            
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                        inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 10580
                    )
					,
					se_review_needed as (
                        select 
                            pps.project_id "project_id",	
                            pps.id "project_process_step_id",	
                            lov.name "text_value",
                            
                            cf.field_name "cf_field_name",
                            cf.id "cf_id",
                            cfga.id "cfga_id"		
                            
                        
                        from flow.project_process_step_custom_field_value ppscfv
                        
                       inner join flow.project_process_step pps on pps.id = ppscfv.project_process_step_id
                        inner join flow.process_step ps on ps.id = pps.process_step_id
                        inner join flow.custom_field_group_assignment cfga 
                            on cfga.id = ppscfv.custom_field_group_assignment_id
                        inner join flow.custom_field cf on cf.id = cfga.custom_field_id
                        inner join flow.list_of_value lov on lov.id = ppscfv.int_value
                        
                        
                        where 
                            ps.id = 3355
                            and 
                            cf.id = 10579
                    )
                    
                    
                    
                    select 
                        p.id "project_id",
                        p.project_name "project_name",	
                        p.contact_id "contact_id", 
                        c.email "contact_email", 
                        u.email "closer_email", 
                        pps.id "project_process_step_id",
                        dt.text_value "design_type",
                        lp.text_value "loan_product",
                        pf.text_value "primary_financier", 
                        lt.text_value "loan_term", 
                        ir.numeric_value "interest_rate", 
                        la.numeric_value "loan_amount", 
                        dafpn.proposal_number "proposal_number",	
                        dafdn.design_number "design_number",
                        kc.text_value "kwh_change",
                        pc.text_value "price_change",
                        cpsst.process_step_status_type "process_step_status",
                        fdst.timestamp_value "fd_sent_timestamp",
						ern.text_value "ee_review_needed",
						srn.text_value "se_review_needed"
                        
                    
                    
                    from 
                        flow.project_process_step pps
                        
                        inner join brs.project_details pd
                            on pd.project_id = pps.project_id 
                        
                        inner join flow.project p
                            on p.id  = pps.project_id 
                        
                        inner join flow.contact c
                            on c.id = p.contact_id 
                        
                        inner join flow.process_step ps
                            on ps.id = pps.process_step_id 
                        
                        inner join flow.company_process_step_status_type cpsst
                            on cpsst.id = 
                                pps.company_process_step_status_type_id 
                        
                        inner join flow.company_project_status_type cpst
                            on cpst.id = p.company_project_status_type_id 
                        
                        inner join flow.user_position up
                            on up.id = p.user_position_id 
                        
                        inner join flow.user u
                            on u.id = up.user_id 
                        
                    left join design_type dt on
                        dt.project_id = pps.project_id
                        and
                        dt.project_process_step_id = pps.id
                    
                    left join loan_product lp on 
                        lp.project_id = pps.project_id 
                        and
                        lp.project_process_step_id = pps.id
                    
                    left join primary_financier pf on 
                        pf.project_id = pps.project_id 
                        and
                        pf.project_process_step_id = pps.id
                    
                    left join loan_term lt on 
                        lt.project_id = pps.project_id 
                        and
                        lt.project_process_step_id = pps.id
                        
                    left join interest_rate ir on 
                        ir.project_id = pps.project_id 
                        and
                        ir.project_process_step_id = pps.id
                        
                    left join loan_amount la on 
                        la.project_id = pps.project_id 
                        and
                        la.project_process_step_id = pps.id
                        
                    left join d_and_f_proposal_number dafpn on 
                        dafpn.project_id = pps.project_id 
                        and
                        dafpn.project_process_step_id = pps.id
                        
                    left join d_and_f_design_number dafdn on 
                        dafdn.project_id = pps.project_id 
                        and
                        dafdn.project_process_step_id = pps.id
                    
                    left join kwh_change kc on
                        kc.project_id = pps.project_id
                        and
                        kc.project_process_step_id = pps.id
                    
                    left join price_change pc on
                        pc.project_id = pps.project_id
                        and
                        pc.project_process_step_id = pps.id
                        
                    left join fd_sent_timestamp fdst on
                        fdst.project_id = pps.project_id
                        and
                        fdst.project_process_step_id = pps.id
						
					left join se_review_needed srn on
						srn.project_id = pps.project_id
						and
						srn.project_process_step_id = pps.id
					
					left join ee_review_needed ern on
						ern.project_id = pps.project_id
						and
						ern.project_process_step_id = pps.id
                       
                    
                    where 
                        ern.text_value != 'Yes'
						and
						srn.text_value != 'Yes'
						and 
                        p.id not in 
                            (
                            select project.id   
                    
                            from flow.project 
                    
                            inner join flow.project_process_step 
                                on project_process_step.project_id = project.id 
                    
                            inner join flow.process_step 
                                on process_step.id = project_process_step.process_step_id 
                    
                            where process_step_name in 
                                (
                                'Regenerate Proposal (Post Install Agreement)',
                                'Needs a Redesign',
                                'Schedule Resurvey', 
                                'Resurvey'
                                ) 
                            )
                                            
                                            
                        and fdst.timestamp_value is null
                        and dt.text_value = 'Final Design'
                        and pps.main = True 
                        and ps.id = 3355 
                        and cpsst.process_step_status_type = 'Ready to Send Final Design' 
                        and cpst.project_status_type_id = 1 
                        and pd.kwh_change = 153 
                        and pd.price_change = 291
"""
